import csv
import wave
import struct
outputarray=[]

outputarray=[0]

with open('abc.csv','r') as csvfile:
    reader=csv.reader(csvfile,delimiter=',')
 
    prevnumbera = 1 ##store previous bit value for column A
    prevnumberb = 1 ##same for B
    header= next(reader) ##shoot past first header line
    header= next(reader) ##shoot past first samples
    header= next(reader)
    prevrowtime=float(header[0]) ##used to detect when one or more pulses are skipped
    prevprevrowtime=float(header[0]) ##used to measure width of pulse
    for row in reader:
        if (round((float(row[0])-prevprevrowtime)>4.2e-05)):
                for j in range(0,(int((float(row[0])-prevprevrowtime)/4.1e-05))):
                    outputarray.append(outputarray[-1])##for every time a data point is missing, just repeat the last point
                    
        else:
            if ((int(row[1])==1) and (prevnumbera==0)):
                outputarray.append(outputarray[-1]+round((float(row[0])-prevrowtime)/(0.3255e-06)))
                #print (float(row[0])-prevrowtime)/(0.3255e-06)
 
            if ((int(row[2])==1) and (prevnumberb==0)):
                outputarray.append(outputarray[-1]-round((float(row[0])-prevrowtime)/(0.3255e-06)))
                #print 0-(float(row[0])-prevrowtime)/(0.3255e-06)
                
              
        outputarray[-1]=outputarray[-1]*.99 #a super mild high pass filter to prevent output from drifting away from zero
        prevprevrowtime=prevrowtime
        prevrowtime=float(row[0])
        prevnumbera=int(row[1])
        prevnumberb=int(row[2])

if (max(outputarray)>abs(max(outputarray))):
    gain = ((2.0**15)-5)/abs(max(outputarray))## the -5 is to keep it safely away from an overflow
else:
    gain = ((2.0**15)-5)/abs(min(outputarray))
with open('pushpull.csv','wb') as csvfile:
	mywriter=csv.writer(csvfile,delimiter = ',')
	for i in outputarray:
		mywriter.writerow([i])
mywave = wave.open('pushpull.wav','w')
mywave.setparams((1,2,24000,0,'NONE','not compressed'))
for i in outputarray:
    mywave.writeframes(struct.pack('h',i*gain))
mywave.close()
